diff --git a/gcc/analyzer/constraint-manager.cc b/gcc/analyzer/constraint-manager.cc
index 786bd6ccf85..2f7a6537493 100644
--- a/gcc/analyzer/constraint-manager.cc
+++ b/gcc/analyzer/constraint-manager.cc
@@ -41,6 +41,9 @@ along with GCC; see the file COPYING3.  If not see
 #include "sbitmap.h"
 #include "bitmap.h"
 #include "tristate.h"
+#include "analyzer/call-string.h"
+#include "analyzer/program-point.h"
+#include "analyzer/store.h"
 #include "analyzer/region-model.h"
 #include "analyzer/constraint-manager.h"
 #include "analyzer/analyzer-selftests.h"
@@ -49,38 +52,17 @@ along with GCC; see the file COPYING3.  If not see
 
 namespace ana {
 
-/* One of the end-points of a range.  */
-
-struct bound
-{
-  bound () : m_constant (NULL_TREE), m_closed (false) {}
-  bound (tree constant, bool closed)
-  : m_constant (constant), m_closed (closed) {}
-
-  void ensure_closed (bool is_upper);
-
-  const char * get_relation_as_str () const;
-
-  tree m_constant;
-  bool m_closed;
-};
-
-/* A range of values, used for determining if a value has been
-   constrained to just one possible constant value.  */
-
-struct range
+static tristate
+compare_constants (tree lhs_const, enum tree_code op, tree rhs_const)
 {
-  range () : m_lower_bound (), m_upper_bound () {}
-  range (const bound &lower, const bound &upper)
-  : m_lower_bound (lower), m_upper_bound (upper) {}
-
-  void dump (pretty_printer *pp) const;
-
-  bool constrained_to_single_element (tree *out);
-
-  bound m_lower_bound;
-  bound m_upper_bound;
-};
+  tree comparison
+    = fold_binary (op, boolean_type_node, lhs_const, rhs_const);
+  if (comparison == boolean_true_node)
+    return tristate (tristate::TS_TRUE);
+  if (comparison == boolean_false_node)
+    return tristate (tristate::TS_FALSE);
+  return tristate (tristate::TS_UNKNOWN);
+}
 
 /* struct bound.  */
 
@@ -120,26 +102,60 @@ bound::get_relation_as_str () const
 /* Dump this range to PP, which must support %E for tree.  */
 
 void
-range::dump (pretty_printer *pp) const
+range::dump_to_pp (pretty_printer *pp) const
+{
+  if (m_lower_bound.m_constant)
+    {
+      if (m_upper_bound.m_constant)
+	pp_printf (pp, "%qE %s x %s %qE",
+		   m_lower_bound.m_constant,
+		   m_lower_bound.get_relation_as_str (),
+		   m_upper_bound.get_relation_as_str (),
+		   m_upper_bound.m_constant);
+      else
+	pp_printf (pp, "%qE %s x",
+		   m_lower_bound.m_constant,
+		   m_lower_bound.get_relation_as_str ());
+    }
+  else
+    {
+      if (m_upper_bound.m_constant)
+	pp_printf (pp, "x %s %qE",
+		   m_upper_bound.get_relation_as_str (),
+		   m_upper_bound.m_constant);
+      else
+	pp_string (pp, "x");
+    }
+}
+
+/* Dump this range to stderr.  */
+
+DEBUG_FUNCTION void
+range::dump () const
 {
-  pp_printf (pp, "%qE %s x %s %qE",
-	     m_lower_bound.m_constant,
-	     m_lower_bound.get_relation_as_str (),
-	     m_upper_bound.get_relation_as_str (),
-	     m_upper_bound.m_constant);
+  pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
+  pp_show_color (&pp) = pp_show_color (global_dc->printer);
+  pp.buffer->stream = stderr;
+  dump_to_pp (&pp);
+  pp_newline (&pp);
+  pp_flush (&pp);
 }
 
 /* Determine if there is only one possible value for this range.
-   If so, return true and write the constant to *OUT.
-   Otherwise, return false.  */
+   If so, return the constant; otherwise, return NULL_TREE.  */
 
-bool
-range::constrained_to_single_element (tree *out)
+tree
+range::constrained_to_single_element ()
 {
+  if (m_lower_bound.m_constant == NULL_TREE
+      || m_upper_bound.m_constant == NULL_TREE)
+    return NULL_TREE;
+
   if (!INTEGRAL_TYPE_P (TREE_TYPE (m_lower_bound.m_constant)))
-    return false;
+    return NULL_TREE;
   if (!INTEGRAL_TYPE_P (TREE_TYPE (m_upper_bound.m_constant)))
-    return false;
+    return NULL_TREE;
 
   /* Convert any open bounds to closed bounds.  */
   m_lower_bound.ensure_closed (false);
@@ -150,12 +166,92 @@ range::constrained_to_single_element (tree *out)
 				 m_lower_bound.m_constant,
 				 m_upper_bound.m_constant);
   if (comparison == boolean_true_node)
+    return m_lower_bound.m_constant;
+  else
+    return NULL_TREE;
+}
+
+/* Eval the condition "X OP RHS_CONST" for X within the range.  */
+
+tristate
+range::eval_condition (enum tree_code op, tree rhs_const) const
+{
+  range copy (*this);
+  if (tree single_element = copy.constrained_to_single_element ())
+    return compare_constants (single_element, op, rhs_const);
+
+  switch (op)
     {
-      *out = m_lower_bound.m_constant;
-      return true;
+    case EQ_EXPR:
+      if (below_lower_bound (rhs_const))
+	return tristate (tristate::TS_FALSE);
+      if (above_upper_bound (rhs_const))
+	return tristate (tristate::TS_FALSE);
+      break;
+
+    case LT_EXPR:
+    case LE_EXPR:
+      /* Qn: "X </<= RHS_CONST".  */
+      /* If RHS_CONST > upper bound, then it's true.
+	 If RHS_CONST < lower bound, then it's false.
+	 Otherwise unknown.  */
+      if (above_upper_bound (rhs_const))
+	return tristate (tristate::TS_TRUE);
+      if (below_lower_bound (rhs_const))
+	return tristate (tristate::TS_FALSE);
+      break;
+
+    case NE_EXPR:
+      /* Qn: "X != RHS_CONST".  */
+      /* If RHS_CONST < lower bound, then it's true.
+	 If RHS_CONST > upper bound, then it's false.
+	 Otherwise unknown.  */
+      if (below_lower_bound (rhs_const))
+	return tristate (tristate::TS_TRUE);
+      if (above_upper_bound (rhs_const))
+	return tristate (tristate::TS_TRUE);
+      break;
+
+    case GE_EXPR:
+    case GT_EXPR:
+      /* Qn: "X >=/> RHS_CONST".  */
+      if (above_upper_bound (rhs_const))
+	return tristate (tristate::TS_FALSE);
+      if (below_lower_bound (rhs_const))
+	return tristate (tristate::TS_TRUE);
+      break;
+
+    default:
+      gcc_unreachable ();
+      break;
     }
-  else
+  return tristate (tristate::TS_UNKNOWN);
+}
+
+/* Return true if RHS_CONST is below the lower bound of this range.  */
+
+bool
+range::below_lower_bound (tree rhs_const) const
+{
+  if (!m_lower_bound.m_constant)
     return false;
+
+  return compare_constants (rhs_const,
+			    m_lower_bound.m_closed ? LT_EXPR : LE_EXPR,
+			    m_lower_bound.m_constant).is_true ();
+}
+
+/* Return true if RHS_CONST is above the upper bound of this range.  */
+
+bool
+range::above_upper_bound (tree rhs_const) const
+{
+  if (!m_upper_bound.m_constant)
+    return false;
+
+  return compare_constants (rhs_const,
+			    m_upper_bound.m_closed ? GT_EXPR : GE_EXPR,
+			    m_upper_bound.m_constant).is_true ();
 }
 
 /* class equiv_class.  */
@@ -163,21 +259,20 @@ range::constrained_to_single_element (tree *out)
 /* equiv_class's default ctor.  */
 
 equiv_class::equiv_class ()
-: m_constant (NULL_TREE), m_cst_sid (svalue_id::null ()),
-  m_vars ()
+: m_constant (NULL_TREE), m_cst_sval (NULL), m_vars ()
 {
 }
 
 /* equiv_class's copy ctor.  */
 
 equiv_class::equiv_class (const equiv_class &other)
-: m_constant (other.m_constant), m_cst_sid (other.m_cst_sid),
+: m_constant (other.m_constant), m_cst_sval (other.m_cst_sval),
   m_vars (other.m_vars.length ())
 {
   int i;
-  svalue_id *sid;
-  FOR_EACH_VEC_ELT (other.m_vars, i, sid)
-    m_vars.quick_push (*sid);
+  const svalue *sval;
+  FOR_EACH_VEC_ELT (other.m_vars, i, sval)
+    m_vars.quick_push (sval);
 }
 
 /* Print an all-on-one-line representation of this equiv_class to PP,
@@ -188,38 +283,43 @@ equiv_class::print (pretty_printer *pp) const
 {
   pp_character (pp, '{');
   int i;
-  svalue_id *sid;
-  FOR_EACH_VEC_ELT (m_vars, i, sid)
+  const svalue *sval;
+  FOR_EACH_VEC_ELT (m_vars, i, sval)
     {
       if (i > 0)
 	pp_string (pp, " == ");
-      sid->print (pp);
+      sval->dump_to_pp (pp, true);
     }
   if (m_constant)
     {
       if (i > 0)
 	pp_string (pp, " == ");
-      pp_printf (pp, "%qE", m_constant);
+      pp_printf (pp, "[m_constant]%qE", m_constant);
     }
   pp_character (pp, '}');
 }
 
-/* Generate a hash value for this equiv_class.  */
+/* Generate a hash value for this equiv_class.
+   This relies on the ordering of m_vars, and so this object needs to
+   have been canonicalized for this to be meaningful.  */
 
 hashval_t
 equiv_class::hash () const
 {
   inchash::hash hstate;
-  int i;
-  svalue_id *sid;
 
   inchash::add_expr (m_constant, hstate);
-  FOR_EACH_VEC_ELT (m_vars, i, sid)
-    inchash::add (*sid, hstate);
+  int i;
+  const svalue *sval;
+  FOR_EACH_VEC_ELT (m_vars, i, sval)
+    hstate.add_ptr (sval);
   return hstate.end ();
 }
 
-/* Equality operator for equiv_class.  */
+/* Equality operator for equiv_class.
+   This relies on the ordering of m_vars, and so this object
+   and OTHER need to have been canonicalized for this to be
+   meaningful.  */
 
 bool
 equiv_class::operator== (const equiv_class &other)
@@ -227,15 +327,15 @@ equiv_class::operator== (const equiv_class &other)
   if (m_constant != other.m_constant)
     return false; // TODO: use tree equality here?
 
-  /* FIXME: should we compare m_cst_sid?  */
+  /* FIXME: should we compare m_cst_sval?  */
 
   if (m_vars.length () != other.m_vars.length ())
     return false;
 
   int i;
-  svalue_id *sid;
-  FOR_EACH_VEC_ELT (m_vars, i, sid)
-    if (! (*sid == other.m_vars[i]))
+  const svalue *sval;
+  FOR_EACH_VEC_ELT (m_vars, i, sval)
+    if (sval != other.m_vars[i])
       return false;
 
   return true;
@@ -244,18 +344,18 @@ equiv_class::operator== (const equiv_class &other)
 /* Add SID to this equiv_class, using CM to check if it's a constant.  */
 
 void
-equiv_class::add (svalue_id sid, const constraint_manager &cm)
+equiv_class::add (const svalue *sval)
 {
-  gcc_assert (!sid.null_p ());
-  if (tree cst = cm.maybe_get_constant (sid))
+  gcc_assert (sval);
+  if (tree cst = sval->maybe_get_constant ())
     {
       gcc_assert (CONSTANT_CLASS_P (cst));
       /* FIXME: should we canonicalize which svalue is the constant
 	 when there are multiple equal constants?  */
       m_constant = cst;
-      m_cst_sid = sid;
+      m_cst_sval = sval;
     }
-  m_vars.safe_push (sid);
+  m_vars.safe_push (sval);
 }
 
 /* Remove SID from this equivalence class.
@@ -263,16 +363,16 @@ equiv_class::add (svalue_id sid, const constraint_manager &cm)
    a possible leak).  */
 
 bool
-equiv_class::del (svalue_id sid)
+equiv_class::del (const svalue *sval)
 {
-  gcc_assert (!sid.null_p ());
-  gcc_assert (sid != m_cst_sid);
+  gcc_assert (sval);
+  gcc_assert (sval != m_cst_sval);
 
   int i;
-  svalue_id *iv;
+  const svalue *iv;
   FOR_EACH_VEC_ELT (m_vars, i, iv)
     {
-      if (*iv == sid)
+      if (iv == sval)
 	{
 	  m_vars[i] = m_vars[m_vars.length () - 1];
 	  m_vars.pop ();
@@ -280,7 +380,7 @@ equiv_class::del (svalue_id sid)
 	}
     }
 
-  /* SID must be in the class.  */
+  /* SVAL must be in the class.  */
   gcc_unreachable ();
   return false;
 }
@@ -288,46 +388,33 @@ equiv_class::del (svalue_id sid)
 /* Get a representative member of this class, for handling cases
    where the IDs can change mid-traversal.  */
 
-svalue_id
+const svalue *
 equiv_class::get_representative () const
 {
-  if (!m_cst_sid.null_p ())
-    return m_cst_sid;
-  else
-    {
-      gcc_assert (m_vars.length () > 0);
-      return m_vars[0];
-    }
-}
-
-/* Remap all svalue_ids within this equiv_class using MAP.  */
-
-void
-equiv_class::remap_svalue_ids (const svalue_id_map &map)
-{
-  int i;
-  svalue_id *iv;
-  FOR_EACH_VEC_ELT (m_vars, i, iv)
-    map.update (iv);
-  map.update (&m_cst_sid);
+  gcc_assert (m_vars.length () > 0);
+  return m_vars[0];
 }
 
 /* Comparator for use by equiv_class::canonicalize.  */
 
 static int
-svalue_id_cmp_by_id (const void *p1, const void *p2)
+svalue_cmp_by_ptr (const void *p1, const void *p2)
 {
-  const svalue_id *sid1 = (const svalue_id *)p1;
-  const svalue_id *sid2 = (const svalue_id *)p2;
-  return sid1->as_int () - sid2->as_int ();
+  const svalue *sval1 = *(const svalue * const *)p1;
+  const svalue *sval2 = *(const svalue * const *)p2;
+  if (sval1 < sval2)
+    return 1;
+  if (sval1 > sval2)
+    return -1;
+  return 0;
 }
 
-/* Sort the svalues_ids within this equiv_class.  */
+/* Sort the svalues within this equiv_class.  */
 
 void
 equiv_class::canonicalize ()
 {
-  m_vars.qsort (svalue_id_cmp_by_id);
+  m_vars.qsort (svalue_cmp_by_ptr);
 }
 
 /* Get a debug string for C_OP.  */
@@ -438,6 +525,32 @@ constraint::operator== (const constraint &other) const
   return true;
 }
 
+/* Return true if this constraint is implied by OTHER.  */
+
+bool
+constraint::implied_by (const constraint &other,
+			 const constraint_manager &cm) const
+{
+  if (m_lhs == other.m_lhs)
+    if (tree rhs_const = m_rhs.get_obj (cm).get_any_constant ())
+      if (tree other_rhs_const = other.m_rhs.get_obj (cm).get_any_constant ())
+	if (m_lhs.get_obj (cm).get_any_constant () == NULL_TREE)
+	  if (m_op == other.m_op)
+	    switch (m_op)
+	      {
+	      default:
+		break;
+	      case CONSTRAINT_LE:
+	      case CONSTRAINT_LT:
+		if (compare_constants (rhs_const,
+				       GE_EXPR,
+				       other_rhs_const).is_true ())
+		  return true;
+		break;
+	      }
+  return false;
+}
+
 /* class equiv_class_id.  */
 
 /* Get the underlying equiv_class for this ID from CM.  */
@@ -473,7 +586,8 @@ equiv_class_id::print (pretty_printer *pp) const
 
 constraint_manager::constraint_manager (const constraint_manager &other)
 : m_equiv_classes (other.m_equiv_classes.length ()),
-  m_constraints (other.m_constraints.length ())
+  m_constraints (other.m_constraints.length ()),
+  m_mgr (other.m_mgr)
 {
   int i;
   equiv_class *ec;
@@ -575,34 +689,54 @@ constraint_manager::print (pretty_printer *pp) const
   pp_printf (pp, "}");
 }
 
-/* Dump a multiline representation of this constraint_manager to PP
+/* Dump a representation of this constraint_manager to PP
    (which must support %E for trees).  */
 
 void
-constraint_manager::dump_to_pp (pretty_printer *pp) const
+constraint_manager::dump_to_pp (pretty_printer *pp, bool multiline) const
 {
-  // TODO
-  pp_string (pp, "  equiv classes:");
-  pp_newline (pp);
+  if (multiline)
+    pp_string (pp, "  ");
+  pp_string (pp, "equiv classes:");
+  if (multiline)
+    pp_newline (pp);
+  else
+    pp_string (pp, " {");
   int i;
   equiv_class *ec;
   FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
     {
-      pp_string (pp, "    ");
+      if (multiline)
+	pp_string (pp, "    ");
+      else if (i > 0)
+	pp_string (pp, ", ");
       equiv_class_id (i).print (pp);
       pp_string (pp, ": ");
       ec->print (pp);
-      pp_newline (pp);
+      if (multiline)
+	pp_newline (pp);
     }
-  pp_string (pp, "  constraints:");
-  pp_newline (pp);
+  if (multiline)
+    pp_string (pp, "  ");
+  else
+    pp_string (pp, "}");
+  pp_string (pp, "constraints:");
+  if (multiline)
+    pp_newline (pp);
+  else
+    pp_string (pp, "{");
   constraint *c;
   FOR_EACH_VEC_ELT (m_constraints, i, c)
     {
-      pp_printf (pp, "    %i: ", i);
+      if (multiline)
+	pp_string (pp, "    ");
+      pp_printf (pp, "%i: ", i);
       c->print (pp, *this);
-      pp_newline (pp);
+      if (multiline)
+	pp_newline (pp);
     }
+  if (!multiline)
+    pp_string (pp, "}");
 }
 
 /* Dump a multiline representation of this constraint_manager to FP.  */
@@ -614,7 +748,7 @@ constraint_manager::dump (FILE *fp) const
   pp_format_decoder (&pp) = default_tree_printer;
   pp_show_color (&pp) = pp_show_color (global_dc->printer);
   pp.buffer->stream = fp;
-  dump_to_pp (&pp);
+  dump_to_pp (&pp, true);
   pp_flush (&pp);
 }
 
@@ -639,13 +773,51 @@ debug (const constraint_manager &cm)
    Return false if the constraint contradicts existing knowledge.  */
 
 bool
-constraint_manager::add_constraint (svalue_id lhs,
-				    enum tree_code op,
-				    svalue_id rhs)
+constraint_manager::add_constraint (const svalue *lhs,
+				     enum tree_code op,
+				     const svalue *rhs)
 {
+  lhs = lhs->unwrap_any_unmergeable ();
+  rhs = rhs->unwrap_any_unmergeable ();
+
+  /* Nothing can be known about unknown values.  */
+  if (lhs->get_kind () == SK_UNKNOWN
+      || rhs->get_kind () == SK_UNKNOWN)
+    /* Not a contradiction.  */
+    return true;
+
+  /* Check the conditions on svalues.  */
+  {
+    tristate t_cond = eval_condition (lhs, op, rhs);
+
+    /* If we already have the condition, do nothing.  */
+    if (t_cond.is_true ())
+      return true;
+
+    /* Reject a constraint that would contradict existing knowledge, as
+       unsatisfiable.  */
+    if (t_cond.is_false ())
+      return false;
+  }
+
   equiv_class_id lhs_ec_id = get_or_add_equiv_class (lhs);
   equiv_class_id rhs_ec_id = get_or_add_equiv_class (rhs);
-  return add_constraint (lhs_ec_id, op,rhs_ec_id);
+
+  /* Check the stronger conditions on ECs.  */
+  {
+    tristate t = eval_condition (lhs_ec_id, op, rhs_ec_id);
+
+    /* Discard constraints that are already known.  */
+    if (t.is_true ())
+      return true;
+
+    /* Reject unsatisfiable constraints.  */
+    if (t.is_false ())
+      return false;
+  }
+
+  add_unknown_constraint (lhs_ec_id, op, rhs_ec_id);
+  return true;
 }
 
 /* Attempt to add the constraint LHS_EC_ID OP RHS_EC_ID to this
@@ -655,8 +827,8 @@ constraint_manager::add_constraint (svalue_id lhs,
 
 bool
 constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
-				    enum tree_code op,
-				    equiv_class_id rhs_ec_id)
+				     enum tree_code op,
+				     equiv_class_id rhs_ec_id)
 {
   tristate t = eval_condition (lhs_ec_id, op, rhs_ec_id);
 
@@ -668,6 +840,18 @@ constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
   if (t.is_false ())
     return false;
 
+  add_unknown_constraint (lhs_ec_id, op, rhs_ec_id);
+  return true;
+}
+
+/* Add the constraint LHS_EC_ID OP RHS_EC_ID to this constraint_manager,
+   where the constraint has already been checked for being "unknown".  */
+
+void
+constraint_manager::add_unknown_constraint (equiv_class_id lhs_ec_id,
+					     enum tree_code op,
+					     equiv_class_id rhs_ec_id)
+{
   gcc_assert (lhs_ec_id != rhs_ec_id);
 
   /* For now, simply accumulate constraints, without attempting any further
@@ -681,14 +865,14 @@ constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
 	const equiv_class &rhs_ec_obj = rhs_ec_id.get_obj (*this);
 
 	int i;
-	svalue_id *sid;
-	FOR_EACH_VEC_ELT (rhs_ec_obj.m_vars, i, sid)
-	  lhs_ec_obj.add (*sid, *this);
+	const svalue *sval;
+	FOR_EACH_VEC_ELT (rhs_ec_obj.m_vars, i, sval)
+	  lhs_ec_obj.add (sval);
 
 	if (rhs_ec_obj.m_constant)
 	  {
 	    lhs_ec_obj.m_constant = rhs_ec_obj.m_constant;
-	    lhs_ec_obj.m_cst_sid = rhs_ec_obj.m_cst_sid;
+	    lhs_ec_obj.m_cst_sval = rhs_ec_obj.m_cst_sval;
 	  }
 
 	/* Drop rhs equivalence class, overwriting it with the
@@ -718,6 +902,12 @@ constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
 	    if (c->m_rhs == final_ec_id)
 	      c->m_rhs = rhs_ec_id;
 	  }
+
+	/* We may now have self-comparisons due to the merger; these
+	   constraints should be removed.  */
+	unsigned read_index, write_index;
+	VEC_ORDERED_REMOVE_IF (m_constraints, read_index, write_index, c,
+			       (c->m_lhs == c->m_rhs));
       }
       break;
     case GE_EXPR:
@@ -740,7 +930,6 @@ constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
       break;
     }
   validate ();
-  return true;
 }
 
 /* Subroutine of constraint_manager::add_constraint, for handling all
@@ -748,11 +937,20 @@ constraint_manager::add_constraint (equiv_class_id lhs_ec_id,
 
 void
 constraint_manager::add_constraint_internal (equiv_class_id lhs_id,
-					     enum constraint_op c_op,
-					     equiv_class_id rhs_id)
+					      enum constraint_op c_op,
+					      equiv_class_id rhs_id)
 {
+  constraint new_c (lhs_id, c_op, rhs_id);
+
+  /* Remove existing constraints that would be implied by the
+     new constraint.  */
+  unsigned read_index, write_index;
+  constraint *c;
+  VEC_ORDERED_REMOVE_IF (m_constraints, read_index, write_index, c,
+			 (c->implied_by (new_c, *this)));
+
   /* Add the constraint.  */
-  m_constraints.safe_push (constraint (lhs_id, c_op, rhs_id));
+  m_constraints.safe_push (new_c);
 
   if (!flag_analyzer_transitivity)
     return;
@@ -762,8 +960,8 @@ constraint_manager::add_constraint_internal (equiv_class_id lhs_id,
       /* The following can potentially add EQ_EXPR facts, which could lead
 	 to ECs being merged, which would change the meaning of the EC IDs.
 	 Hence we need to do this via representatives.  */
-      svalue_id lhs = lhs_id.get_obj (*this).get_representative ();
-      svalue_id rhs = rhs_id.get_obj (*this).get_representative ();
+      const svalue *lhs = lhs_id.get_obj (*this).get_representative ();
+      const svalue *rhs = rhs_id.get_obj (*this).get_representative ();
 
       /* We have LHS </<= RHS */
 
@@ -833,13 +1031,13 @@ constraint_manager::add_constraint_internal (equiv_class_id lhs_id,
 		      range r (bound (lhs_const, c_op == CONSTRAINT_LE),
 			       bound (other_rhs_const,
 				      other->m_op == CONSTRAINT_LE));
-		      tree constant;
-		      if (r.constrained_to_single_element (&constant))
+		      if (tree constant = r.constrained_to_single_element ())
 			{
-			  svalue_id cst_sid = get_sid_for_constant (constant);
+			  const svalue *cst_sval
+			    = m_mgr->get_or_create_constant_svalue (constant);
 			  add_constraint
 			    (rhs_id, EQ_EXPR,
-			     get_or_add_equiv_class (cst_sid));
+			     get_or_add_equiv_class (cst_sval));
 			  return;
 			}
 		    }
@@ -865,13 +1063,13 @@ constraint_manager::add_constraint_internal (equiv_class_id lhs_id,
 				      other->m_op == CONSTRAINT_LE),
 			       bound (rhs_const,
 				      c_op == CONSTRAINT_LE));
-		      tree constant;
-		      if (r.constrained_to_single_element (&constant))
+		      if (tree constant = r.constrained_to_single_element ())
 			{
-			  svalue_id cst_sid = get_sid_for_constant (constant);
+			  const svalue *cst_sval
+			    = m_mgr->get_or_create_constant_svalue (constant);
 			  add_constraint
 			    (lhs_id, EQ_EXPR,
-			     get_or_add_equiv_class (cst_sid));
+			     get_or_add_equiv_class (cst_sval));
 			  return;
 			}
 		    }
@@ -887,11 +1085,13 @@ constraint_manager::add_constraint_internal (equiv_class_id lhs_id,
     }
 }
 
-/* Look for SID within the equivalence classes of this constraint_manager;
-   if found, write the id to *OUT and return true, otherwise return false.  */
+/* Look for SVAL within the equivalence classes of this constraint_manager;
+   if found, return true, writing the id to *OUT if OUT is non-NULL,
+   otherwise return false.  */
 
 bool
-constraint_manager::get_equiv_class_by_sid (svalue_id sid, equiv_class_id *out) const
+constraint_manager::get_equiv_class_by_svalue (const svalue *sval,
+					       equiv_class_id *out) const
 {
   /* TODO: should we have a map, rather than these searches?  */
   int i;
@@ -899,31 +1099,41 @@ constraint_manager::get_equiv_class_by_sid (svalue_id sid, equiv_class_id *out)
   FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
     {
       int j;
-      svalue_id *iv;
+      const svalue *iv;
       FOR_EACH_VEC_ELT (ec->m_vars, j, iv)
-	if (*iv == sid)
+	if (iv == sval)
 	  {
-	    *out = equiv_class_id (i);
+	    if (out)
+	      *out = equiv_class_id (i);
 	    return true;
 	  }
     }
   return false;
 }
 
-/* Ensure that SID has an equivalence class within this constraint_manager;
+/* Ensure that SVAL has an equivalence class within this constraint_manager;
    return the ID of the class.  */
 
 equiv_class_id
-constraint_manager::get_or_add_equiv_class (svalue_id sid)
+constraint_manager::get_or_add_equiv_class (const svalue *sval)
 {
   equiv_class_id result (-1);
 
-  /* Try svalue_id match.  */
-  if (get_equiv_class_by_sid (sid, &result))
+  gcc_assert (sval->get_kind () != SK_UNKNOWN);
+
+  /* Convert all NULL pointers to (void *) to avoid state explosions
+     involving all of the various (foo *)NULL vs (bar *)NULL.  */
+  if (POINTER_TYPE_P (sval->get_type ()))
+    if (tree cst = sval->maybe_get_constant ())
+      if (zerop (cst))
+	sval = m_mgr->get_or_create_constant_svalue (null_pointer_node);
+
+  /* Try svalue match.  */
+  if (get_equiv_class_by_svalue (sval, &result))
     return result;
 
   /* Try equality of constants.  */
-  if (tree cst = maybe_get_constant (sid))
+  if (tree cst = sval->maybe_get_constant ())
     {
       int i;
       equiv_class *ec;
@@ -936,7 +1146,7 @@ constraint_manager::get_or_add_equiv_class (svalue_id sid)
 				   cst, ec->m_constant);
 	    if (eq == boolean_true_node)
 	      {
-		ec->add (sid, *this);
+		ec->add (sval);
 		return equiv_class_id (i);
 	      }
 	  }
@@ -945,12 +1155,12 @@ constraint_manager::get_or_add_equiv_class (svalue_id sid)
 
   /* Not found.  */
   equiv_class *new_ec = new equiv_class ();
-  new_ec->add (sid, *this);
+  new_ec->add (sval);
   m_equiv_classes.safe_push (new_ec);
 
   equiv_class_id new_id (m_equiv_classes.length () - 1);
 
-  if (maybe_get_constant (sid))
+  if (sval->maybe_get_constant ())
     {
       /* If we have a new EC for a constant, add constraints comparing this
 	 to other constants we may have (so that we accumulate the transitive
@@ -975,10 +1185,10 @@ constraint_manager::get_or_add_equiv_class (svalue_id sid)
 		add_constraint_internal (new_id, CONSTRAINT_LT, other_id);
 	      else if (lt == boolean_false_node)
 		add_constraint_internal (other_id, CONSTRAINT_LT, new_id);
-	      /* Refresh new_id, in case ECs were merged.  SID should always
+	      /* Refresh new_id, in case ECs were merged.  SVAL should always
 		 be present by now, so this should never lead to a
 		 recursion.  */
-	      new_id = get_or_add_equiv_class (sid);
+	      new_id = get_or_add_equiv_class (sval);
 	    }
 	}
     }
@@ -991,7 +1201,7 @@ constraint_manager::get_or_add_equiv_class (svalue_id sid)
 tristate
 constraint_manager::eval_condition (equiv_class_id lhs_ec,
 				    enum tree_code op,
-				    equiv_class_id rhs_ec)
+				    equiv_class_id rhs_ec) const
 {
   if (lhs_ec == rhs_ec)
     {
@@ -1015,12 +1225,10 @@ constraint_manager::eval_condition (equiv_class_id lhs_ec,
   tree rhs_const = rhs_ec.get_obj (*this).get_any_constant ();
   if (lhs_const && rhs_const)
     {
-      tree comparison
-	= fold_binary (op, boolean_type_node, lhs_const, rhs_const);
-      if (comparison == boolean_true_node)
-	return tristate (tristate::TS_TRUE);
-      if (comparison == boolean_false_node)
-	return tristate (tristate::TS_FALSE);
+      tristate result_for_constants
+	= compare_constants (lhs_const, op, rhs_const);
+      if (result_for_constants.is_known ())
+	return result_for_constants;
     }
 
   enum tree_code swapped_op = swap_tree_comparison (op);
